import { Injectable } from '@angular/core';
import { HttpClient } from '@angular/common/http';
import { BehaviorSubject, Observable } from 'rxjs';
import { Router } from '@angular/router';
import { auth } from  'firebase/app';
import { AngularFireAuth } from  "@angular/fire/auth";
import { User } from 'firebase';
import { StorageService } from '@app/core/services/storage/storage.service';
import { LogService } from '@app/core/services/log/log.service';

// import * as config from '@assets/config.json';

@Injectable( { providedIn: 'root' } )
export  class  AuthService {
    user:  User;

    constructor(public  afAuth:  AngularFireAuth, public  router:  Router) {
		this.afAuth.authState.subscribe(user => {
       if (user) {
         this.user = user;
         localStorage.setItem('user', JSON.stringify(this.user));
       } else {
         localStorage.setItem('user', null);
       }
     })
  }

	async  login(email:  string, password:  string) {

  	try {
  		await  this.afAuth.auth.signInWithEmailAndPassword(email, password)
  		this.router.navigate(['register/list']);
  	} catch (e) {
  		alert("Error!"  +  e.message);
  	}
  	}

  	async logout(){
  		await this.afAuth.auth.signOut();
  		localStorage.removeItem('user');
  		this.router.navigate(['/register']);
  	}

  	get isLoggedIn(): boolean {
  		const  user  =  JSON.parse(localStorage.getItem('user'));
  		return  user  !==  null;
  	}

	public get currentUserValue(): User {
	  // if ( this.currentUserSubject.value && this.currentUserSubject.value.timeGetToken + 60 * 60 * 1000 < new Date().getTime() ) {
	  //   const data = new FormData();

	  // data.append( 'auth_token', this.currentUserSubject.value.token );
	  // this.http.post<any>( environment.baseUrl + config.url.upauth, data ).subscribe( ( res ) => {
	  //   if ( res.statusCode !== 200 ) {
	  //     this.logout();
	  //   } else {
	  //     this.currentUserSubject.value.timeGetToken = new Date().getTime();
	  //     this.stor.setLocal( 'user', this.currentUserSubject.value );
	  //   }
	  // } );
	  // }
	  return //this.currentUserSubject.value;
	}
}
